<?php
/**
 * Demo Deployment Tool
 *
 * @version		1.2.0
 * @author		Martin Rasser, Elovaris Web Development
 * @copyright	Copyright (C) 2009 Elovaris Web Development. All rights reserved.
 * 				Borrows some code from the Joomla! project (Password generation)
 * @license		GNU/GPL (http://www.gnu.org/licenses/gpl-2.0.html)
 */
define('PROPER_ENTRY',true);

if (!isset($_GET['name']) || !trim($_GET['name'])) {
	die('no name');
}

if (!isset($_GET['email']) || !trim($_GET['email'])) {
	die('email');
}

$name = addslashes($_GET['name']);
$email = addslashes($_GET['email']);

$language = $_GET['language'];
// Strip any .. occurences to twarth file include tricks
$language = str_replace('..','',$language);
$language = addslashes($language);


require_once('configuration.php');
require_once('includes.php');

file_put_contents($logfile,date(DATE_RFC822)."\nDemo for ".$_GET['email']."\n\n\n 0: Starting \n",FILE_APPEND); $stop = time(); 

// Determine demo number
$names = array();
$root = realpath($destFolder.$baseFolder);
if ($handle = opendir($destFolder.$baseFolder)) {
    while (false !== ($file = readdir($handle))) {
        if ($file != "." && $file != ".." && substr($file,0,1) != '.') {
        	$path = $root.'/'.$file;
			if (is_dir($path) && strstr($file,$folderPrefix)) {
				$names[] = str_replace($folderPrefix,'', $file);
			}           
        }
    }
    closedir($handle);
}

sort($names);


$demoNumber = (int)array_pop($names) + 1;
file_put_contents($logfile,date(DATE_RFC822)."\nDemo for ".$_GET['email']."\n\n\n". time() - $stop.': Determine demo number'."\n",FILE_APPEND); $stop = time(); 

// Create folder

$destinationFolder = $destFolder.$baseFolder.$folderPrefix.$demoNumber.'/';
$databaseName = $dbPrefix.$demoNumber;

if (file_exists($destinationFolder) ) {
	die('folder already exists. Demonumber: '.$demoNumber);
}

$succ = mkdir($destinationFolder,0755,true);

if (!$succ) die ('could not create folder "'.$destinationFolder.'"');

$file = $srcFolder.$srcFile;

// Extract files
$output = array();
$return = '';

$command = 'unzip '.$file.' -d '.$destinationFolder;

exec($command, $output, $return);

if ($return !== 0) die('could not unzip files.');

file_put_contents($logfile, time() - $stop .': Unzip files'."\n",FILE_APPEND); $stop = time(); 

	
//	$command = 'chown -R '.$fileSystemOwner.':'.$fileSystemGroup.' '.$destinationFolder;
//	exec($command, $output, $return);
//	
//	if ($return !== 0) {
//		echo('could not chown files.');
//	}
	
$command = 'chmod -R 755 '.$destinationFolder;
exec($command, $output, $return);

if ($return !== 0) {
	die('could not chmod files.');
}

// Modify htaccess
$fileContent = file_get_contents($destinationFolder.'htaccess.txt');

$fileContent = str_replace('# RewriteBase /', 'RewriteBase /'.$demoBaseUrl.$baseFolder.$folderPrefix.$demoNumber, $fileContent);

$succ = file_put_contents($destinationFolder.'.htaccess', $fileContent);
if (!$succ) die('could not write "'.$destinationFolder.'.htaccess'.'"');


// Modify configuration.php
$fileContent = file_get_contents($destinationFolder.'configuration.php');

$fileContent = str_replace('XX',$demoNumber,$fileContent);
$fileContent = str_replace('BASEPATH',$destinationFolder,$fileContent);
$fileContent = str_replace('DBUSERNAME',$dbUsername,$fileContent);
$fileContent = str_replace('DBPASSWORD',$dbPassword,$fileContent);
$fileContent = str_replace('DBDATABASE',$databaseName,$fileContent);
$fileContent = str_replace('FTPROOT',$ftpRoot.$demoNumber,$fileContent);
$fileContent = str_replace('FTPUSER',$ftpUser,$fileContent);
$fileContent = str_replace('FTPPASSWORD',$ftpPassword,$fileContent);
	
file_put_contents($destinationFolder.'configuration.php', $fileContent);
if (!$succ) die('could not write "'.$destinationFolder.'configuration.php'.'"');

file_put_contents($logfile, time() - $stop .': write configuration file'."\n",FILE_APPEND); $stop = time(); 

// Create database

$command = $mysqlBin." -u $dbUsername --password=$dbPassword -e 'CREATE DATABASE IF NOT EXISTS `$databaseName` CHARACTER SET utf8 COLLATE utf8_general_ci;'";
$output = system($command, $return);

if ($return !== 0) die('could not create database.');
	
file_put_contents($logfile, time() - $stop .': Create database'."\n",FILE_APPEND); $stop = time(); 


// Insert structure and data
$command = $mysqlBin.' -u '.$dbUsername.' --password='.$dbPassword .' --database='.$databaseName.' < '.$srcFolderDb.$srcFileDb;
$output = system($command, $return);

if ($return !== 0) die('could not populate database.');

file_put_contents($logfile, time() - $stop .': Populate database'."\n",FILE_APPEND); $stop = time(); 


// Determine username/password/name/usergroup
$username = $defaultUsername;
$passwordClear = genRandomPassword(8);

$usergroup = '23';
$salt		= genRandomPassword(32);
$crypt		= getCryptedPassword($passwordClear, $salt);
$passwordCrypted	= $crypt.':'.$salt;
	
// Set up user
mysql_connect('localhost',$dbUsername,$dbPassword);
mysql_select_db($databaseName);

$query = 'SET NAMES UTF8';
$res = mysql_query($query);

$query = "INSERT INTO `jos_users` VALUES(NULL, '$name','$username', '$email', '".addslashes($passwordCrypted)."', 'Manager', 0, 0, $usergroup, NOW(), '0000-00-00 00:00:00', '', 'admin_language=$language\nlanguage=$language\neditor=\nhelpsite=\ntimezone=0\n\n');";
$res = mysql_query($query);

if ($res == false) {
	echo $query."\n";
	die('Could not add user.'.mysql_error());
}

$insertID = mysql_insert_id();

$query = "INSERT INTO `jos_core_acl_aro` VALUES(NULL, 'users', $insertID, 0, 'Manager', 0);";
$res = mysql_query($query);

if ($res == false) {
	echo $query."\n";
	die('Could not add user acl aro record.'.mysql_error());
}

$insertID = mysql_insert_id();

$query = "INSERT INTO `jos_core_acl_groups_aro_map` VALUES(23, '', $insertID);";
$res = mysql_query($query);

if ($res == false) {
	echo $query."\n";
	die('Could not add user acl groups aro record.'.mysql_error());
}

file_put_contents($logfile, time() - $stop .': Insert user credentials in database'."\n",FILE_APPEND); $stop = time(); 

// Save record
mysql_connect('localhost',$systemUsername,$systemPassword);
mysql_select_db($systemDatabase);

$url = $hostName.'/'.$demoBaseUrl.$baseFolder.$folderPrefix.$demoNumber;

$query = 'SET NAMES UTF8';
$res = mysql_query($query);

$query = "INSERT INTO `demos` SET `name` = '".$name."', `email` = '".$email."', `url` = '".$url."', `date_created` = NOW()";
$res = mysql_query($query);
if ($res == false) {
	die('Could not add record.'.mysql_error());
}

if ($appendLanguageCode) {
	$url = $url .'/'.substr($language,0,2);
}

file_put_contents($logfile, time() - $stop .': Log demo request'."\n",FILE_APPEND); $stop = time(); 


// Prepare email body
ob_clean();
ob_start();


$languageFile = './language/'.strtolower($language).'.php';
if (file_exists($languageFile)) {
	include($languageFile);
}
else {
	require('./language/'.strtolower($fallBackLanguage).'.php');
}

$emailBody = ob_get_clean();

file_put_contents($logfile, time() - $stop .': Get e-mail content'."\n",FILE_APPEND); $stop = time(); 

header('Cache-Control: no-cache, must-revalidate');
header('Content-type: application/json');
echo $_REQUEST['callback'].'(';
echo json_encode($response);
echo ')';

// Prepare the plain text version
$plaintext = str_replace('<br />',"\n", $emailBody);
$plaintext = str_replace(chr(9),"", $emailBody);
$plaintext = strip_tags($plaintext);

// Wrap long lines
$plaintext = mb_wordwrap($plaintext, $width=74, $break="=\n");
$emailBody = mb_wordwrap($emailBody, $width=74, $break="=\n");

file_put_contents($logfile, time() - $stop .': word wrap e-mail content'."\n",FILE_APPEND); $stop = time(); 


$boundary = "QWERTZUIOPASDFGHJKLYXCVBNM";

$headers  = 'MIME-Version: 1.0' . "\r\n";
$headers .= 'From: '.$senderName.' <'.$senderEmail.'>' . "\r\n";
$headers .= "Content-Type: multipart/alternative;
	boundary=\"$boundary\"\r\n";

$message = "\n";
$message .="This is a multi-part message in MIME format.\n";
$message .="\n";

$message .= "--".$boundary."\n";
$message .="Content-Type: text/plain; charset=utf-8\n";
$message .="Content-Transfer-Encoding: Quoted-printable\n";
$message .="Content-Disposition: inline\n";
$message .="\n";
$message .= $plaintext."\n";
$message .= "--".$boundary."\n";


$message.="Content-Type: text/html; charset=utf-8\n";
$message.="Content-Transfer-Encoding: Quoted-printable\n";
$message.="Content-Disposition: inline\n";
$message.="\n";
$message .= $emailBody."\n";
$message .= "--".$boundary."--\r\n";

file_put_contents($logfile, time() - $stop .': Setup emails'."\n",FILE_APPEND); $stop = time(); 


$succ = mail($name.' <'.$email.'>', "=?UTF-8?B?".base64_encode($subjectUser).'?=', $message, $headers);
$succ = mail($adminBame.' <'.$adminEmail.'>', "=?UTF-8?B?".base64_encode($subjectAdmin . $name.', '.$email).'?=', $message, $headers);
file_put_contents($logfile, time() - $stop .': Send emails. Done.'."\n",FILE_APPEND); $stop = time(); 
?>